routes/web.php
<?php

use App\Http\Controllers\QuestionController;
use App\Http\Controllers\QuestionsOptionsController;
use App\Http\Controllers\ResultsController;
use App\Http\Controllers\TopicController;
use App\Http\Controllers\UserController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::get('/dashboard', [TopicController::class, 'index'])->name('dashboard');

Route::resource('users', UserController::class);
Route::resource('topics', TopicController::class);
Route::resource('questions', QuestionController::class);
Route::resource('options', QuestionsOptionsController::class);
Route::get('/results/score', [ResultsController::class, 'score'])->name('results.score');
Route::resource('results', ResultsController::class);


require __DIR__ . '/auth.php';

app/Models/Topic.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasMany;

class Topic extends Model
{
    public const TIMOUT = 600;
    protected $table = 'topics';

    protected $fillable = ['title'];

    public static function getDeadLine(int $started): string
    {
        return date('Y-m-d H:i:s', $started + self::TIMOUT);
    }

    public function questions(): HasMany
    {
        return $this->hasMany('App\Models\Question', 'topic_id', 'id');
    }

    public function getSessionKey(int $userId): string
    {
        return 'startTopic_'.$userId.'_'.$this->id;
    }
}

app/Http/Controllers/TopicController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\StoreTopicRequest;
use App\Http\Requests\UpdateTopicRequest;
use App\Models\Topic;
use Illuminate\Contracts\Foundation\Application;
use Illuminate\Contracts\View\Factory;
use Illuminate\Contracts\View\View;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Routing\Redirector;
use Illuminate\Support\Facades\Auth;

class TopicController extends Controller
{
    public function __construct()
    {
        $this->middleware('auth');
        $this->middleware('admin')->except(['index', 'show']);
    }

    public function index(): Factory|View|Application
    {
        $topics = Topic::all();

        return view('topics.index', ['topics' => $topics]);
    }

    public function create(): Factory|View|Application
    {
        $topics = Topic::all();

        return view('topics.create', ['topics' => $topics]);
    }

    public function store(StoreTopicRequest $request): Redirector|Application|RedirectResponse
    {
        $topic = new Topic();
        $topic->title = $request->input('title');
        $topic->save();

        return redirect(route('topics.edit', ['topic' => $topic->id]));
    }

    public function show(Request $request, int $id): Factory|View|Application
    {
        $topic = Topic::find($id);
        $key = $topic->getSessionKey(Auth::user()->id);
        $started = $request->session()->get($key, null);

        if (empty($started)) {
            $request->session()->put([$key => time()]);
            $started = $request->session()->get($key);
        }

        return view('topics.show', ['topic' => $topic, 'deadline' => Topic::getDeadLine($started)]);
    }

    public function edit(int $id): Factory|View|Application
    {
        $topic = Topic::find($id);

        return view('topics.edit', ['topic' => $topic]);
    }

    public function update(UpdateTopicRequest $request, int $id): Redirector|Application|RedirectResponse
    {
        $topic = Topic::find($id);
        $topic->title = $request->input('title');
        $topic->save();

        return redirect(route('topics.index'));
    }

    public function destroy(int $id): Redirector|Application|RedirectResponse
    {
        $topic = Topic::find($id);
        $topic->delete();

        return redirect(route('topics.index'));
    }
}

app/View/Components/AppLayout.php
<?php

namespace App\View\Components;

use Illuminate\View\Component;

class AppLayout extends Component
{
    /**
     * Get the view / contents that represents the component.
     *
     * @return \Illuminate\View\View
     */
    public function render()
    {
        return view('layouts.app');
    }
}

resources/views/topics/create.blade.php
<x-app-layout>
    <x-slot name="header">
        <h2 class="font-semibold text-xl text-gray-800 leading-tight">
            {{ __('Create new Quiz') }}
        </h2>
    </x-slot>
    <div class="py-12">
        <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
            <div class="bg-white overflow-hidden shadow-sm sm:rounded-lg">
                <div class="d-flex" id="wrapper">
                    <div class="container">
                        @if ($errors->any())
                            <div class="alert alert-danger">
                                <ul>
                                    @foreach ($errors->all() as $error)
                                        <li>{{ $error }}</li>
                                    @endforeach
                                </ul>
                            </div>
                        @endif
                        <div class="form-group">
                            <hr>
                            <form action="{{route('topics.store')}}" method="post">
                                @csrf
                                <div class="form-group">
                                    <input type="text" name="title" class="form-control" placeholder="Title">
                                </div>
                                <input type="submit" name="submit" id="submit" class="btn btn-info"
                                       value="Create Topic"/>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</x-app-layout>

resources/views/topics/edit.blade.php
<x-app-layout>
    <x-slot name="header">
        <h2 class="font-semibold text-xl text-gray-800 leading-tight">
            {{ __('Edit topic') }} : {{$topic->title}}
        </h2>
    </x-slot>
    <div class="py-12">
        <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
            <div class="bg-white overflow-hidden shadow-sm sm:rounded-lg">
                <div class="container">
                    @if($topic)
                        @if ($errors->any())
                            <div class="alert alert-danger">
                                <ul>
                                    @foreach ($errors->all() as $error)
                                        <li>{{ $error }}</li>
                                    @endforeach
                                </ul>
                            </div>
                        @endif
                        <div class="row">
                            <div class="col-md-12">
                                <div class="form-group">
                                    <hr>
                                    <form action="{{route('topics.update', $topic->id)}}" method="post">
                                        @csrf
                                        @method('put')
                                        <div class="form-group">
                                            <input required type="text" name="title" class="form-control"
                                                   value="{{$topic->title}}">
                                        </div>
                                        <input type="submit" name="submit" id="submit" class="btn btn-info"
                                               value="Update Topic Title">
                                    </form>
                                </div>
                            </div>

                            <div class="col-md-12">
                                <div class="form-group">
                                    <hr>
                                    <form action="{{route('questions.store')}}" method="post">
                                        @csrf
                                        <input type="hidden" name="topic" id="inputState" value="{{$topic->id}}">
                                        <div>
                                            <h2 class="mt-2" align="center">Add new question</h2>
                                            <table class="table table-bordered " id="dynamic_field">
                                                <thead>
                                                <tr>
                                                    <th>Question</th>
                                                    <th>Answer options</th>
                                                    <th>Correct</th>
                                                    <th>Binary</th>
                                                </tr>
                                                </thead>
                                                <tbody>
                                                <tr>
                                                    <td>
                                                        <input type="text" name="question" placeholder="Question"
                                                               class="form-control question_list" required
                                                        />
                                                    <td>
                                                        <input type="text" name="options[]" placeholder="Answer"
                                                               class="form-control options_list question-answer"
                                                               required
                                                        />
                                                    </td>
                                                    <td>
                                                        <input type="checkbox"
                                                               name="correct[]"
                                                               value="1"
                                                               placeholder="Is correct"
                                                               class="form-control"
                                                        />
                                                    </td>
                                                    <td>
                                                        <input type="checkbox"
                                                               name="binary[]"
                                                               value="1"
                                                               placeholder="Is binary"
                                                               class="cbx-binary form-control"
                                                        />
                                                    </td>
                                                    </td>
                                                    <td>
                                                        <button type="button" name="addAnswer" id="addAnswer"
                                                                class="btn btn-success mb-2">
                                                            Add Answer
                                                        </button>
                                                    </td>
                                                </tr>
                                                </tbody>
                                            </table>
                                            <input type="submit" name="addQuestion" id="addQuestion"
                                                   class="btn btn-success mb-2 mr-2"
                                                   value="Add Question"/>
                                        </div>
                                    </form>
                                </div>
                            </div>
                        </div>
                        <script type="text/javascript">

                            function getTemplate(n) {
                                return '<tr id="row' + n + '" class="dynamic-added">' +
                                    '<td>' +
                                    '</td>' +
                                    '<td>' +
                                    '<input type="text" name="options[]" required placeholder="Other answer" class="form-control question_list question-answer" />' +
                                    '</td>' +
                                    '<td>' +
                                    '<input type="checkbox" name="correct[]" value="' + n + '" class="form-control question_list" />' +
                                    '</td>' +
                                    '<td>' +
                                    '<input type="checkbox" name="binary[]" value="' + n + '" class="cbx-binary form-control question_list" />' +
                                    '</td>' +
                                    '<td>' +
                                    '<button type="button" name="remove" id="' + n + '" class="btn btn-danger btn_remove">X</button>' +
                                    '</td>' +
                                    '</tr>';
                            }

                            function updateBinaryCheckBox(element) {
                                let checked = $(element).prop('checked');
                                if (checked) {
                                    let value = 'True';
                                    if ($('#dynamic_field tbody tr').length == 1) {
                                        $('#dynamic_field tbody').append(getTemplate(2));
                                    }
                                    $('#dynamic_field tbody tr').each(function (index, element) {
                                        console.log(index);
                                        if (index == 1) {
                                            value = 'False';
                                        } else {
                                            if (index > 1) {
                                                $(element).remove();

                                                return;
                                            }
                                        }

                                        $(element).find('input[type="text"].question-answer').prop('readonly', true);
                                        $(element).find('input[type="text"].question-answer').val(value);
                                        $('.cbx-binary').prop('checked', true);
                                    });

                                    $('#addAnswer').addClass('hidden');
                                } else {
                                    $('#addAnswer').removeClass('hidden');
                                    $('#dynamic_field tbody tr').each(function (index, element) {
                                        $(element).find('input[type="text"].question-answer').prop('readonly', false);
                                        $(element).find('.cbx-binary').prop('checked', false);
                                    });
                                    n = 2;
                                }
                            }

                            $(document).ready(function () {
                                var n = 1;

                                $('#addAnswer').click(function () {
                                    n++;
                                    let template = getTemplate(n);
                                    $('#dynamic_field tbody').append(template);
                                });

                                $('.cbx-binary').on('click', function (e) {
                                    updateBinaryCheckBox(this)
                                })

                                $(document).on('click', '.btn_remove', function () {
                                    var button_id = $(this).attr("id");
                                    $('#row' + button_id + '').remove();
                                });

                            });
                        </script>
                    @else
                        <h1>No Topic</h1>
                    @endif
                </div>
            </div>
        </div>
    </div>
    </div>
</x-app-layout>

resources/views/topics/index.blade.php
<x-app-layout>
    <x-slot name="header">
        <h2 class="font-semibold text-xl text-gray-800 leading-tight">
            {{ __('Topics') }}

            @if(Auth::user())
                @if(Auth::user()->role == 'admin')
                    <a class="text-sm text-gray-600 hover:text-gray-900" href="{{ route('topics.create') }}">
                        <x-button class="ml-4">
                            {{ __('Create new topic') }}
                        </x-button>
                    </a>
                @endif
            @endif

        </h2>
    </x-slot>
    <div class="py-12">
        <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
            <div class="bg-white overflow-hidden shadow-sm sm:rounded-lg">
                <div class="d-flex" id="wrapper">
                    <div class="container">
                        <div class="row">
                            <div class="col-md-6 mt-4 mb-4">
                                @if(count($topics))
                                    @foreach($topics as $topic)
                                        <div class="card">
                                            <div class="card-body mb-2 inline-block">
                                                <h5 class="card-title">{{$topic->title}}</h5>
                                                <a href="{{route('topics.show', $topic->id)}}"
                                                   class="inline-block btn btn-primary">Go
                                                    To Quiz</a>
                                                @if(Auth::user())
                                                    @if(Auth::user()->role == 'admin')
                                                        <a href="{{route('topics.edit', $topic->id)}}"
                                                           class="inline_block btn btn-warning">Edit</a>
                                                        <form class="inline-flex"
                                                              action="{{route('topics.destroy', $topic->id)}}"
                                                              method="post">
                                                            @csrf
                                                            @method('delete')
                                                            <button class="btn btn-xs btn-danger" type="submit">Delete
                                                            </button>
                                                        </form>
                                                    @endif
                                                @endif
                                            </div>
                                        </div>
                                    @endforeach
                                @else
                                    <h1>No Topics</h1>
                                @endif
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</x-app-layout>

resources/views/topics/show.blade.php
<x-app-layout>
    <x-slot name="header">
        <h2 class="font-semibold text-xl text-gray-800 leading-tight">
            {{$topic->title}}
        </h2>

    </x-slot>
    <div class="py-12">
        <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
            <div class="bg-white overflow-hidden shadow-sm sm:rounded-lg">
                <div class="container">
                    @if($topic)
                        @if ($errors->any())
                            <div class="alert alert-danger">
                                <ul>
                                    @foreach ($errors->all() as $error)
                                        <li>{{ $error }}</li>
                                    @endforeach
                                </ul>
                            </div>
                        @endif
                        <div class="row">
                            <div class="col-md-12">
                                <div id="clockdiv"> Remaining time</div>
                                <form action="{{route('results.store')}}" method="post" id="question">
                                    @csrf
                                    <div>
                                        <input type="hidden" name="topic_id" value="{{$topic->id}}">
                                        @foreach($topic->questions as $question )
                                            <div>
                                                {{$question->text}}
                                                <input type="hidden" name="question_id[]" value="{{$question->id}}">
                                                @foreach($question->options as $option)
                                                    <div>
                                                        @if ($option->binary)
                                                            <input type="radio"
                                                                   name="option[{{$question->id}}][]"
                                                                   value="{{$option->id}}">
                                                            {{$option->option}}
                                                        @else
                                                            <input type="checkbox"
                                                                   name="option[{{$question->id}}][]"
                                                                   value="{{$option->id}}">
                                                            {{$option->option}}
                                                        @endif
                                                    </div>
                                                @endforeach
                                            </div>
                                        @endforeach
                                    </div>
                                    <a href="{{route('results.show', $topic->id)}}"><input type="submit" value="Submit"
                                                                                           class="btn btn-success mt-3"></a>
                                </form>
                            </div>
                        </div>
                    @else
                        <h1>No Topic</h1>
                    @endif
                </div>
            </div>
        </div>
    </div>
</x-app-layout>
<script>
    const deadline = '{{ $deadline }}';

    function getTimeRemaining(endtime) {
        const total = Date.parse(endtime) - Date.parse(new Date());
        const seconds = Math.floor((total / 1000) % 60);
        const minutes = Math.floor((total / 1000 / 60) % 60);
        const hours = Math.floor((total / (1000 * 60 * 60)) % 24);
        const days = Math.floor(total / (1000 * 60 * 60 * 24));

        return {total, days, hours, minutes, seconds};
    }

    function initializeClock(id, endtime) {
        const clock = document.getElementById(id);
        const timeinterval = setInterval(() => {
            const t = getTimeRemaining(endtime);
            // clock.innerHTML = 'days: ' + t.days + '<br>' +
            //     'hours: ' + t.hours + '<br>' +
            //     'minutes: ' + t.minutes + '<br>' +
            //     'seconds: ' + t.seconds;
            clock.innerHTML = ('0' + t.minutes).slice(-2) + ':' + ('0' + t.seconds).slice(-2);
            if (t.total <= 0) {
                clearInterval(timeinterval);
                clock.innerHTML = 'Running out...';
                $('form#question').submit();
            }
        }, 1000);
    }

    initializeClock('clockdiv', deadline);
</script>
<style>
    #clockdiv {
        display: inline-flex;
        float: right;
        border: 1px solid black;
        padding: 15px;
    }
</style>